"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.prefilterOnEventTypes = exports.filterOnEventType = exports.filterOnContent = void 0;
var _isArray = _interopRequireDefault(require("lodash/isArray"));
var _isFunction = _interopRequireDefault(require("lodash/isFunction"));
const filterOnEventType = (rule, uow) => {
  uow.debug && uow.debug('filterOnEventType: ', rule.eventType, uow.event.type);
  if (typeof rule.eventType === 'string') {
    return uow.event.type === rule.eventType;
  } else if (rule.eventType instanceof RegExp) {
    return rule.eventType.test(uow.event.type);
  } else if ((0, _isArray.default)(rule.eventType)) {
    return rule.eventType.join().indexOf(uow.event.type) > -1;
  } else if ((0, _isFunction.default)(rule.eventType)) {
    return rule.eventType(uow.event.type, rule);
  } else {
    throw new Error(`Rule: ${rule.id}, has improperly configured eventType filter. Must be a string, array of string, regex or function.`);
  }
};
exports.filterOnEventType = filterOnEventType;
const prefilterOnEventTypes = rules => uow => rules.reduce((a, c) => a || filterOnEventType(c, uow), false);
exports.prefilterOnEventTypes = prefilterOnEventTypes;
const filterOnContent = (rule, uow) => {
  /* istanbul ignore else */
  if (rule.filters) {
    return rule.filters.reduce((a, c) => a && c(uow, rule), true);
  } else {
    return true;
  }
};
exports.filterOnContent = filterOnContent;