"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.metrics = void 0;
var pipelines = _interopRequireWildcard(require("./pipelines"));
var capture = _interopRequireWildcard(require("./capture"));
var toPromise = _interopRequireWildcard(require("./to-promise"));
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function (e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && Object.prototype.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
const enabled = key => process.env.METRICS.includes(key) || process.env.METRICS.includes('*');

// handler middleware
const metrics = (next, opt, evt, ctx) => {
  /* istanbul ignore else */
  if (process.env.METRICS?.length) {
    opt.metrics = {
      ...pipelines,
      ...capture,
      ...toPromise,
      enabled
    };

    /* istanbul ignore else */
    if (process.env.METRICS.includes('xray') && process.env.AWS_XRAY_DAEMON_ADDRESS) {
      opt.xrayEnabled = true;
    }
  }

  // could collect metrics here
  return next();
  // could collect metrics here in .tap() and .tapCatch()
};
exports.metrics = metrics;