"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.toPromise = void 0;
var _highland = _interopRequireDefault(require("highland"));
var _bluebird = _interopRequireDefault(require("bluebird"));
var _pipelines = require("./pipelines");
var _calculate = require("./calculate");
var _emf = require("./emf");
const toPromise = (opt, s) => new _bluebird.default((resolve, reject) => {
  (0, _pipelines.clear)(opt);
  const collected = [];
  s.consume((err, x, push, next) => {
    /* istanbul ignore if */
    if (err) {
      reject(err);
    } else if (x === _highland.default.nil) {
      const metrics = (0, _calculate.calculateMetrics)(collected);
      (0, _emf.logMetrics)(metrics);
      resolve(metrics);
    } else {
      collected.push(x);
      next();
    }
  }).resume();
});
exports.toPromise = toPromise;