"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.printStartPipeline = exports.printStart = exports.printEndPipeline = exports.printEnd = exports.debug = void 0;
var _uow = require("./uow");
const debug = exports.debug = require('debug'); // eslint-disable-line global-require

const printStartPipeline = uow => {
  printStart(uow.debug)(uow);
};
exports.printStartPipeline = printStartPipeline;
const printEndPipeline = uow => {
  printEnd(uow.debug)(uow);
};
exports.printEndPipeline = printEndPipeline;
const printStart = dbug => uow => {
  dbug('start type: %s, eid: %s', uow.event.type, uow.event.id);
};
exports.printStart = printStart;
const printEnd = dbug => uow => {
  dbug('end type: %s, eid: %s, uow: %j', uow.event.type, uow.event.id, (0, _uow.trimAndRedact)(uow));
};
exports.printEnd = printEnd;