"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.splitObject = void 0;
var _isFunction = _interopRequireDefault(require("lodash/isFunction"));
var _get = _interopRequireDefault(require("lodash/get"));
var _faults = require("./faults");
const splitObject = ({
  // eslint-disable-line import/prefer-default-export
  splitOn,
  splitTargetField = 'split',
  ...rule
}) => {
  if (splitOn) {
    if ((0, _isFunction.default)(splitOn)) {
      return s => s.flatMap((0, _faults.faulty)(uow => splitOn(uow, rule)));
    } else {
      return s => s.flatMap((0, _faults.faulty)(uow => {
        const values = (0, _get.default)(uow, splitOn);
        return values.map(v => ({
          ...uow,
          [splitTargetField]: v
        }));
      }));
    }
  } else {
    return s => s;
  }
};
exports.splitObject = splitObject;